<template>
  <div class="card card-lg h-100">
    <div class="card-body p-3">
      <div class="row justify-content-center g-0">
        <div class="col">
          <h3 class="strong mb-0">{{ set.title }}</h3>
        </div>
        <div class="col col-auto mr-1">
          <div class="row justify-content-center g-3">
            <div class="col col-auto">
              <ChevronLeftIcon class="icon-xxs" />
              <a
                v-if="previousSet"
                href="#"
                class="small"
                @click="clickPrevious"
              >
                Previous
              </a>
              <span v-else class="small text-muted"> Previous </span>
            </div>
            <div class="col">
              <a v-if="nextSet" href="#" class="small" @click="clickNext">
                Next
              </a>
              <span v-else class="small text-muted"> Next </span>
              <ChevronRightIcon class="icon-xxs" />
            </div>
          </div>
        </div>
      </div>
      <div class="mt-2">
        <div class="d-flex justify-content-between">
          <div class="avatar-list">
            <template v-for="providerAvatar in providerAvatars">
              <Avatar
                v-if="providerAvatar.type === 'icon'"
                :key="providerAvatar.index"
                badge="bg-online"
              >
                <component :is="providerAvatar.src + '-icon'" />
              </Avatar>
              <Avatar
                v-if="providerAvatar.type === 'image'"
                :key="providerAvatar.index"
                :img="'/avatars/' + providerAvatar.src"
                badge="bg-online"
              />
            </template>
          </div>
          <b-form-group
            label-cols="4"
            label-size="sm"
            label="Execution title:"
            label-align-sm="right"
            label-for="job-title"
            class="d-flex align-items-center m-0 w-50"
          >
            <b-form-input
              id="job-title"
              v-imask="mask"
              size="sm"
              placeholder="(optional)"
              :disabled="scenarioIsRunning"
              :value="getJobTitle"
              @focusout="updateJobTitle"
              @keyup.enter="updateJobTitle"
            ></b-form-input>
          </b-form-group>
        </div>
      </div>
      <div class="mt-3 h-100">
        <div class="table-responsive h-100" style="overflow-x: visible">
          <table class="table card-table table-vcenter datatable small">
            <thead>
              <tr>
                <th class="w-1">Name</th>
                <th>Value</th>
                <th class="fit"></th>
              </tr>
            </thead>
            <tbody class="hover-table">
              <tr
                v-for="parameter in inputChildren"
                :id="parameter.key"
                :key="parameter.index"
                class="clickable-row"
                :class="{ active: isActiveRow(parameter.key) }"
              >
                <td class="col-sce-param-title">
                  <span
                    v-b-tooltip.hover.top="{ variant: 'dark' }"
                    class="sce-param-title text-reset d-inline-block text-truncate"
                    style="width: 250px"
                    :title="parameter.title"
                  >
                    {{ parameter.title
                    }}{{
                      parameter.required === true ||
                      hasRequiredOnValidate(parameter)
                        ? '*'
                        : ''
                    }}
                  </span>
                </td>
                <td class="col-sce-param-value">
                  <component
                    :is="`ParametersCardInput${inputType(parameter.type)}`"
                    :parameter="parameter"
                    :add-properties="addProperties"
                    :disabled="scenarioIsRunning"
                    :change-state-scenario="changeStateScenario"
                    :validations="validations"
                    :update-value="updateValue"
                  >
                  </component>
                  <small v-if="parameter.hint" class="form-text text-muted">
                    <div id="tags-validation-help">{{ parameter.hint }}</div>
                  </small>
                </td>
                <td class="col-sce-param-actions text-right">
                  <div class="align-text-top fit">
                    <ParametersCardActions
                      :parameter="parameter"
                      :disabled="scenarioIsRunning"
                      :update-value="updateValue"
                    />
                  </div>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
      <div class="mt-5"></div>
    </div>
  </div>
</template>

<script>
import * as validators from 'vuelidate/lib/validators';
import { IMaskDirective } from 'vue-imask';
import regexParser from 'regex-parser';
import notificationsMixin from '~/mixins/notifications.js';
const parameterInputs = {
  'string+inputmask+text': 'String',
  'string+select': 'SingleSelect',
  'string+dataset-id': 'DatasetDropdown',
  'string+dataset-file-id': 'DatasetFileDropdown',
  'string+dataset-file-field': 'DatasetFileFieldDropdown',
  'string+query-factory': 'QueryFactory',
  'string+range': 'Range',
  'string+select+multiple': 'MultipleSelect',
  'string+inputmask+int': 'Int',
  'string+inputmask+float': 'Float',
  'string+boolean': 'Boolean',
  'string+select+multiple+int': 'MultipleInt',
  'string+select+multiple+float': 'MultipleFloat',
  'string+select+multiple+text': 'MultipleString',
};

export default {
  directives: {
    imask: IMaskDirective,
  },
  mixins: [notificationsMixin],
  props: {
    set: {
      type: Object,
      default: () => {},
    },
    previousSet: {
      type: Object,
      default: () => {},
    },
    nextSet: {
      type: Object,
      default: () => {},
    },
  },
  data() {
    return {
      mask: {
        mask: /^.{0,50}$/,
      },
    };
  },
  computed: {
    isActiveRow() {
      return (key) => {
        return (
          key ===
          this.$nuxt.context.store.getters['parameters/activeSet'].paramKey
        );
      };
    },
    getJobTitle() {
      return this.$store.getters['projects/getTitleLastJobScenario'];
    },
    scenarioIsRunning() {
      const runningScenario = this.$store.getters[
        'projects/projectRunningScenario'
      ](this.$nuxt.$route.params.id);
      return this.$nuxt.$route.params.scenarioId === runningScenario.id;
    },
    providerAvatars() {
      const setProviders = this.set.providers;
      const allAvatars = this.$nuxt.context.store.state.ui.providerLogos;
      const avatars = Object.entries(allAvatars)
        .filter((entry) => setProviders.includes(entry[0])) // filter by key
        .map((entry) => entry[1]); // return value
      if (avatars.length === 0) {
        avatars.push(allAvatars.default);
      }
      return avatars;
    },
    inputChildren() {
      return this.set.parameters.filter((p) => p.type !== 'group');
    },
  },
  methods: {
    updateJobTitle(e) {
      if (this.getJobTitle !== e.target.value) {
        this.$nuxt.context.store
          .dispatch('projects/changeJobTitle', {
            projectId: this.$nuxt.$route.params.id,
            scenarioId: this.$nuxt.$route.params.scenarioId,
            title: e.target.value,
          })
          .then(() => {
            this.$nuxt.context.store.dispatch('projects/fetchProjectSummary', {
              id: this.$nuxt.$route.params.id,
            });
            this.showNotification(
              'The job title was updated successfully',
              'Job title Updated!'
            );
          })
          .catch(() => {
            this.showErrorNotification('Error updating job title');
          });
      }
    },
    inputType(parameterType) {
      return parameterInputs[parameterType];
    },
    clickNext() {
      this.$nuxt.context.store.dispatch('parameters/setActiveSet', {
        newActiveSet: {
          set: this.nextSet.key,
        },
      });
    },
    clickPrevious() {
      this.$nuxt.context.store.dispatch('parameters/setActiveSet', {
        newActiveSet: {
          set: this.previousSet.key,
        },
      });
    },
    changeStateScenario(paramKey, hasError) {
      this.$nuxt.context.store.dispatch('scenarios/updateValidation', {
        scenarioId: this.$nuxt.$route.params.scenarioId,
        field: paramKey,
        hasError,
      });
    },
    hasRequiredOnValidate(parameter) {
      if (parameter.validate) {
        const indexRequired = parameter.validate.findIndex((param) => {
          const [key] = Object.entries(param)[0];
          return key === 'required';
        });
        return indexRequired !== -1;
      }
      return false;
    },
    validations(parameter) {
      const validation = {
        [parameter.key]: {},
      };
      if (parameter.required && !this.hasRequiredOnValidate(parameter)) {
        validation[parameter.key] = {
          required: validators.required,
        };
      }
      if (parameter.validate) {
        parameter.validate.forEach((val) => {
          const key = Object.keys(val)[0];
          const value = Object.values(val)[0];
          let validator;
          if (key === '$each') {
            const validationEach = {};
            Object.entries(value).forEach(([key, value]) => {
              validationEach[key] = this.getValidator(key, value);
            });
            validator = validationEach;
          } else if (key === 'regex') {
            validator = validators.helpers.regex(
              'regex',
              new RegExp(regexParser(value))
            );
          } else {
            validator = this.getValidator(key, value);
          }
          validation[parameter.key] = {
            ...validation[parameter.key],
            [key]: validator,
          };
        });
      }
      return validation;
    },
    getValidator(validationKey, validationValue) {
      if (
        (Object.prototype.hasOwnProperty.call(validators, validationKey) &&
          typeof validators[validationKey] === 'function') ||
        validationKey === 'regex'
      ) {
        let validator;
        if (Array.isArray(validationValue)) {
          if (typeof validationValue[0] === 'object') {
            const newArray = [];
            validationValue.forEach((val) => {
              const key = Object.keys(val)[0];
              const value = Object.values(val)[0];
              newArray.push(this.getValidator(key, value));
            });
            validator = validators[validationKey].apply(this, newArray);
          } else {
            validator = validators[validationKey].apply(this, validationValue);
          }
        } else if (
          [
            'required',
            'alpha',
            'alphaNum',
            'numeric',
            'integer',
            'decimal',
            'email',
            'ipAddress',
            'url',
          ].includes(validationKey)
        ) {
          validator = validators[validationKey];
        } else if (validationKey === 'regex') {
          validator = validators.helpers.regex(
            'regex',
            new RegExp(regexParser(validationValue))
          );
        } else {
          validator = validators[validationKey](validationValue);
        }
        return validator;
      } else {
        // TODO: Warnings/Errors MUST be logged on the server side
      }
    },
    async updateValue(key, newValue) {
      await this.$nuxt.context.store
        .dispatch('parameters/update', {
          projectId: this.$nuxt.$route.params.id,
          scenarioId: this.$nuxt.$route.params.scenarioId,
          key,
          newValue,
        })
        .catch(() => {
          this.$nuxt.context.store.dispatch(
            'parameters/setErrorUpdatingConfig',
            {
              projectId: this.$nuxt.$route.params.id,
              scenarioId: this.$nuxt.$route.params.scenarioId,
            }
          );
          this.showErrorNotification('Error updating parameter');
        });
    },
    addProperties(parameter, element) {
      const properties = {};
      if (element && parameter.options && parameter.options.properties) {
        const allPossibleProperties = [
          ...Object.keys(HTMLElement.prototype),
          ...Object.keys(Element.prototype),
          ...Object.keys(element.prototype),
        ];
        Object.entries(parameter.options.properties).forEach(([key, value]) => {
          if (key === 'class') {
            properties.class = value;
          } else if (allPossibleProperties.includes(key)) {
            properties[key] = value;
          } else {
            console.log(
              `The property ${key} is not supported for the component`
            );
          }
        });
      }
      return properties;
    },
  },
};
</script>
